/* bxbasm : Asmutils.c : alpha version */
/* ----- function prototypes ----- */
#include "prototyp.h"




void Do_asm()				/* write to asm file */
{
    write_str("  ");
    write_str(p_string);
}
/*---------- end Do_asm ----------*/


void write_str(char *string)			/* write to asm file */
{
    fprintf(f_out,"%s", string);
}
/*---------- end write_str ----------*/


void writeln(char *string)			/* write to asm file */
{
    write_str(string);
    fprintf(f_out, "\n");
}
/*---------- end writeln ----------*/


void s_write_str(char *string)		/* write to string temp file */
{
    fprintf(s_datatemp,"%s", string);
}
/*---------- end s_write_str ----------*/


void s_writeln(char *string)			/* write to string temp file */
{
    s_write_str(string);
    fprintf(s_datatemp, "\n");
}
/*---------- end s_writeln ----------*/


void i_write_str(char *string)		/* write to integer temp file */
{
    fprintf(i_datatemp,"%s", string);
}
/*---------- end i_write_str ----------*/


void i_writeln(char *string)			/* write to integer temp file */
{
    i_write_str(string);
    fprintf(i_datatemp, "\n");
}
/*---------- end i_writeln ----------*/


void f_write_str(char *string)		/* write to float temp file */
{
    fprintf(f_datatemp,"%s", string);
}
/*---------- end f_write_str ----------*/


void f_writeln(char *string)			/* write to float temp file */
{
    f_write_str(string);
    fprintf(f_datatemp, "\n");
}
/*---------- end f_writeln ----------*/


void PostLabel(char *string)			/* Post a Label To Output */
{
    fprintf(f_out, "%s:\n", string);
}
/*---------- end PostLabel ----------*/


char *get_varname()
{   char ch;
    static char varname[VAR_NAME];
    int pi, si=0;

    pi = e_pos;
    ch = p_string[pi];
    while((isalnum(ch) != 0))
    {   varname[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    varname[si] = '\0';
    e_pos = pi;
    return varname;
}
/*---------- end get_varname ----------*/


char *get_NewLabel()				/* generate a unique label */
{   char Val[6];
    static char NewLabel[LLEN];

    UnqLblNdx++;
    strcpy(NewLabel, "Unq_");
    sprintf(Val, "%d", UnqLblNdx);		/* generate an index */
    strcat(NewLabel, Val);
    strcat(NewLabel, "_Label");
    return NewLabel;
}
/*---------- end get_NewLabel ----------*/


double get_avalue()
{   char ch, varname[VAR_NAME];
    int pi, si=0;
    double value=0;

    pi = e_pos;
    ch = p_string[pi];
    if((isdigit(ch)) || (IsAddop(ch)))    /* this is a number */
    {   if(IsAddop(ch))
        {   varname[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        while(isdigit(ch) != 0)
        {   varname[si] = ch;
            pi++;
            si++;
            ch = p_string[pi];
        }
        varname[si] = '\0';
        value = atof(varname);      /* convert alpha to float */
    }
    pi = iswhite(pi);
    e_pos = pi;
    return value;
}
/*-------- end get_avalue --------*/


int check_arrayName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, bool=0;
						/* ArryNdx;     name array */
						/* ArryNdxCnt;  counter */
    strcpy(varname, name);
    if(ArryNdxCnt == 0)			/* no arrays exist yet */
    {   InitArrays();
        ndx = (ArryNdxCnt-1);
        strcpy(ArryNdx[ndx], varname);
    }
    else
    {   while((ndx < ArryNdxCnt) && (strcmp(varname, ArryNdx[ndx]) != 0))
        {   ndx++;
        }
        if(ndx >= ArryNdxCnt)		/* array name does not exist */
        {   InitArrays();
            ndx = (ArryNdxCnt-1);
            strcpy(ArryNdx[ndx], varname);
        }
        else
        {   bool = 1;			/* array name exists */
        }
    }
    return bool;
}
/*---------- end check_arrayName ----------*/


void InitArrays()
{   int ndx;
    unsigned size;
						/* ArryNdx;     name array */
						/* ArryNdxCnt;  counter */
    if(ArryNdxCnt == 0)
    {   ndx = ArryNdxCnt;
        ArryNdxCnt++;
        size = ArryNdxCnt;
        ArryNdx = malloc(size * sizeof(char *));
        ArryParams = malloc(size * sizeof(int));
        size = VAR_NAME;
        ArryNdx[ndx] = malloc(size * sizeof(char));
    }
    else
    {   ndx = ArryNdxCnt;
        ArryNdxCnt++;
        size = ArryNdxCnt;
        ArryNdx = realloc(ArryNdx, size * sizeof(char *));
        ArryParams = realloc(ArryNdx, size * sizeof(int));
        size = VAR_NAME;
        ArryNdx[ndx] = malloc(size * sizeof(char));
    }
}
/*---------- end InitArrays ----------*/


int get_paramsCount(int pi, int len)
{   char ch;
    int xcnt=0;

    ch = p_string[pi];
    while((ch != ')') && (pi < len))	/* get params count */
    {   pi = get_alnum(pi, len);
        ch = p_string[pi];
        if(isalnum(ch))
        {   xcnt++;
            pi = get_NextOp(pi);
            ch = p_string[pi];
        }
    }        
    return xcnt;
}
/*---------- end get_paramsCount ----------*/




