/* bxbasm.c : masm32 alpha version.1.5 */

/* #define Power_C */
#define LccWin32

/* --- declare headers --- */
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <malloc.h>
#include <math.h>

#ifdef Power_C
    #include <bios.h>    	/* Power-C version */
#endif
#ifdef LccWin32
    #include <tcconio.h> 	/* LccWin32 version */
#endif


/* --- declare constants --- */
#define BUFSIZE     256
#define TOKEN_LEN   21
#define VAR_NAME    33
#define LLEN        33
#define IOARRAY     99
#define PATH        129
#define REC_LEN     128



/* ------ global vars ------------ */
    FILE *f_in, *f_out;      /* these are the i/o file handles    */
    FILE *s_datatemp;        /* these are the i/o file handles    */
    FILE *i_datatemp;        /* these are the i/o file handles    */
    FILE *f_datatemp;        /* these are the i/o file handles    */
    char *prog_name;         /* program source-file name          */
    char p_string[BUFSIZE];  /* file input string                 */
    char **array1;           /* program array                     */
    char t_holder[20];       /* token data holder                 */
    char s_holder[BUFSIZE];  /* xstring (print) data holder       */
     int nrows;              /* numbers of lines in source file   */
     int ncolumns=BUFSIZE;   /* dimension for array1[][columns]   */
     int line_ndx;           /* current execution line            */
     int s_pos, e_pos;       /* pointers to start & end of token  */
    char xstring[BUFSIZE];   /* the print string                  */
    char **temp_prog;        /* temp program array                */
    char **temp_label;       /* temp label name array             */
     int *temp_byte;         /* temp byte code array              */
     int *byte_array;        /* byte code array                   */
    char **label_nam;        /* labels name array                 */
     int token;              /* token: current byte code          */
     int var_type;           /* current variable type             */
     int var_count=0;        /* variables counter                 */
    char **VarIndx;          /* unique variables name index       */
     int VarNdxCnt=0;        /* unique variables count            */
     int UnqLblNdx=0;        /* unique labels count               */
    char **ForArray;         /* FOR: nested FOR labels            */
     int forLabelCtr=0;      /* FOR: nested label counter         */
    char indent[BUFSIZE] = {0,0}; /* IF: indentation string       */
     int indcnt=0;           /* IF: indentations for nested code  */
     int opcntr=0;           /* IF: number of nested ANDs/ORs     */
    char **label_endif;      /* IF: array, nested labels          */
     int endifCtr=-1;        /* IF: nested ENDIF counter          */
    char **label_block;      /* IF: array, nested blocks          */
    char label_Or[LLEN];     /* IF: label, OR                     */
     int Or_pi=0;            /* IF:                               */
    char **label_elseif;     /* ELSEIF: array, nested ELSEIF's    */
    char **label_else;       /* ELSE: array, nested ELSE's        */

/*--- FLAGS ---*/
     int stringcopy=0;       /* Flag: string copy: function       */
     int asnchrstr=0;        /* Flag: CHR$ function               */
     int asnleftstr=0;       /* Flag: LEFT$ function              */
     int asnrightstr=0;      /* Flag: RIGHT$ function             */
     int asnmidstr=0;        /* Flag: MID$ function               */
     int asnspacestr=0;      /* Flag: SPACE$ function             */
     int asnstrsIval=0;      /* Flag: STR$(integer) function      */
     int asnstrsFval=0;      /* Flag: STR$(double) function       */
     int asnstringstr=0;     /* Flag: STRING$ function            */
     int asninkeystr=0;      /* Flag: INKEY$  function            */
     int asninputstr=0;      /* Flag: INPUT$  function            */
     int asnmkdstr=0;        /* Flag: MKD$    function            */
     int asnmkistr=0;        /* Flag: MKI$    function            */
     int asnmkqstr=0;        /* Flag: MKI$ (quad) function        */
     int resetcursor=0;      /* Flag: INPUT   function            */
     int getsysdate=0;       /* Flag: DATE    function            */
     int getsystime=0;       /* Flag: TIME    function            */
     int asndatestr=0;       /* Flag: DATE$   function            */
     int asntimestr=0;       /* Flag: DATE$   function            */
     int filecloseall=0;     /* Flag: close all files function    */
     int closeafile=0;       /* Flag: close a file function       */
     int getfilehandle=0;    /* Flag: get file handle function    */
     int clearstrngbffr=0;   /* Flag: clear I/O string function   */
     int setupiobuffer=0;    /* Flag: file I/O buffer function    */
     int asnlsetstr=0;       /* Flag: file LSET string function   */
     int asnrsetstr=0;       /* Flag: file RSET string function   */
     int clearallvars=0;     /* Flag: CLEAR variables function    */
     int clearstrvar=0;      /* Flag: CLEAR string    function    */
     int clearintvar=0;      /* Flag: CLEAR integer   function    */
     int clearfltvar=0;      /* Flag: CLEAR float     function    */
     int clearLngstrngbffr=0; /* Flag: clear i/o string function  */
     int movstrngbffr=0;     /* Flag: move input string function  */
     int readintstr=0;       /* Flag: move input integer function */
     int readfltstr=0;       /* Flag: move input float function   */
     int readQintstr=0;      /* Flag: move input integer function */
     int getfilelength=0;    /* Flag: LOF function                */
     int setcolortext=0;     /* Flag: COLOR function              */
     int dimstrarray=0;      /* Flag: DIM type:string function    */
     int getArryOffst=0;     /* Flag: array offset function       */

/*--- FLAGS ---*/

    char **WhileArray;       /* WHILE: nested While labels        */
     int whileLblCtr=0;      /* WHILE: nested label counter       */
    char wlabel_block[LLEN]; /* WHILE: block label                */
    char **LoopArray;        /* LOOP: nested LOOP labels          */
     int loopLblCtr=0;       /* LOOP: nested label counter        */
    char **BreakArray;       /* BREAK: nested LOOP labels         */
     int breakCtr=0;         /* BREAK: nested BREAK counter       */
     int dowhileflag=0;      /* FLAG: DO-WHILE                    */

/*------ dynamic arrays ------*/
    char **ArryNdx;          /* Array: name array                 */
     int *ArryParams;        /* Array: parameters count array     */
     int ArryNdxCnt=0;       /* Array: counter                    */

    char **Integers;         /* Array: integer name array         */
     int int_cnt=0;          /* Array: counter                    */
    char **LongInts;         /* Array: long integer name array    */
     int Lint_cnt=0;         /* Array: counter                    */
    char **floats;           /* Array: floats name array          */
     int flt_cnt=0;          /* Array: counter                    */
    char **doubles;          /* Array: doubles name array         */
     int dbl_cnt=0;          /* Array: counter                    */
    char **strings;          /* Array: integer name array         */
     int str_cnt=0;          /* Array: counter                    */
/*------ all arrays are dynamic ------*/

/**/
  struct field_buffer        /* File: Field Buffer structure      */
     {   char *f_bffr;            /* I/O buffer */
     unsigned bfr_size;           /* buffer length */
          int *str_len;           /* string length */
         char **str_name;         /* string name */
          int fld_count;          /* number of strings */
         long record;             /* current record number */
          int flag;               /* PUT flag, to clear buffer */
     };                      /* File: handles structure           */
/**/
  struct field_buffer fld_bffr[IOARRAY];

     int lset_ndx;           /* File: global Lset/Rset var_index  */
  struct lset_rset
     {    int ndx;
          int cnt;
     } lrs;
/**/




/* ----- function prototypes ----- */
    void pgm_parser(void);
    void get_token(void);
    void parser(void);
    void num_label(void);
    void dump(void);

#include "prototyp.h"


/* --- function includes --- */
#include "input.c"
#include "utility.c"
#include "asminput.c"
#include "asmutils.c"
#include "asmfunct.c"
#include "asmerror.c"
#include "asmvars.c"
#include "asmrdp.c"
#include "asmninpt.c"
#include "asmloops.c"
#include "asmif.c"
#include "asmstrng.c"
#include "asmfile.c"


/* ----- begin program ------------- */

int main(int argc, char *argv[])
{   int x=0, ab_code=1;
    char CR1[36] = {"Copyright: Blunt_Axe_Basic, BxbAsm,"};
    char CR2[28] = {" Bxbasic (c) sarbayo, 2004"};
    char Ver[20] = {"Alpha Release: 1.05"};

    printf("%s%s\n%s%\n%s\n",CR1,CR2,Ver,"Bxbasm Compiler");
    if(argc != 2)
    {    a_bort(ab_code, x);
    }
    strcpy(t_holder, argv[1]);
    init_fldbffrs();       /* initialize file buffers */
    line_cnt(argv);
    Header();
    pgm_parser();
    Epilog();
    /* assemble(); */

    /* --- end of program --- */
    clr_arrays();
    return 0;
}
/*---------- end main ----------*/

void pgm_parser()
{
    line_ndx = 0;
    while(line_ndx < nrows)
    {   s_pos = 0;
        e_pos = 0;
        get_token();
        parser();
        line_ndx++;
    }
}
/*---------- end pgm_parser ----------*/

void get_token()
{
    strcpy(p_string, array1[line_ndx]);
    token = byte_array[line_ndx];
}
/*---------- end get_token ----------*/

void parser()
{   int ab_code=4, x=line_ndx;

    if(token != -1)
    {   num_label();	/* write a numeric label */
    }
    switch(token)
    {   case 1:		/* LET */
            Do_let();
            break;
        case 2:		/* CLEAR  (variables) */
            clr_vars();
            break;
        case 3:		/* LOCATE */
            Do_locate();
            break;
        case 4:		/* PRINT */
            Do_print();
            break;
        case 5:		/* GOTO */
            Do_goto();
            break;
        case 6:		/* BEEP */
            Do_beep();
            break;
        case 7:		/* CLS */
            Do_cls();
            break;
        case 8:		/* END */
            Do_end();
            break;
        case 9:		/* GOSUB */
            Do_gosub();
            break;
        case 10:		/* RETURN */
            Do_return();
            break;
        case 11:		/* FOR */
            Do_for();
            break;
        case 12:		/* NEXT */
            Do_next();
            break;
        case 13:		/* IF */
            Do_if();
            break;
        case 14:		/* ELSEIF */
            Do_elseif();
            break;
        case 15:		/* ELSE */
            Do_else();
            break;
        case 16:		/* ENDIF */
            Do_endif();
            break;
        case 17:		/* INPUT */
            get_input();
            break;
        case 18:		/* LINE INPUT */
            get_lninput();
            break;
        case 19:		/* OPEN */
            parse_open();
            break;
        case 20:		/* CLOSE */
            Do_fclose();
            break;
        case 21:		/* WRITE */
            write_io();
            break;
        case 22:		/* FIELD */
            Do_field();
            break;
        case 23:		/* LSET */
            Do_lset();
            break;
        case 24:		/* RSET */
            Do_rset();
            break;
        case 25:		/* PUT */
            Do_put();
            break;
        case 26:		/* GET */
            Do_get();
            break;
        case 27:		/* CHDIR */
            parse_chd();
            break;
        case 28:		/* MKDIR */
            parse_mkd();
            break;
        case 29:		/* RMDIR */
            parse_rmd();
            break;
        case 30:		/* KILL */
            parse_kill();
            break;
        case 31:		/* NAME-RENAME */
            parse_name();
            break;
        case 32:		/* FILES */
            parse_shell();
            break;
        case 33:		/* SHELL */
            parse_shell();
            break;
        case 34:    	/* RANDOM */
            seed_rand();
            break;
        case 35:    	/* READ */
            input_io();
            break;
        case 36:    	/* CHDRIVE */
            parse_chdrive();
            break;
        case 37:    	/* WHILE */
            Do_while();
            break;
        case 38:    	/* WEND */
            Do_wend();
            break;
        case 39:    	/* LOOP */
            Do_loop();
            break;
        case 40:    	/* ENDLOOP */
            Do_endloop();
            break;
        case 41:    	/* BREAK */
            Do_break();
            break;
        case 42:    	/* DO-WHILE */
            Do_do();
            break;
        case 43:    	/* LPRINT */
            Do_lprint();
            break;
        case 44:    	/* COLOR */
            Do_color();
            break;
        case 45:    	/* ASM */
            Do_asm();
            break;
        case 46:    	/* DIM */
            Do_dim();
            break;


        case 99:		/* dump */
            dump();
            break;
        case -1:		/* block label */
            Do_label();
            break;
        default:
            a_bort(ab_code, x);
            break;
    }
}
/*---------- end parser ----------*/


void dump()						/* diagnostic tool */
{  int ii;

    for(ii = 0; ii < nrows; ii++)
    {
        printf("%d: %s:%s", ii, label_nam[ii], array1[ii]);
    }
    exit(0);
}
/* ----------- end dump ---------- */


void num_label()				/* post a numeric line label */
{   char ch, label[LLEN];

    ch = label_nam[line_ndx][0];
    if(isdigit(ch))
    {   strcpy(label, "L");
        strcat(label, label_nam[line_ndx]);
        PostLabel(label);			/* Post Label To Output */
    }
}
/* ------- end num_label ------- */

